$(document).ready(function () {
    $("body").off('click').on("click", '.remove', remove);
    $("body").on("keyup change blur focus", ".qty, .rate, .amount,.discperc,.discamt,.vatperc", calDetail);
    $("body").on("keyup change blur focus", ".ldiscperc, .tvatperc, .totdisc, .totadv", mainCal);
//    $("body").on("focus blur change", ".vouchdt", getvoucher);
//    $("body").on("change blur", ".cmbparty", getgst);
    $("body").on("blur", '.rate', autoaddrow);
    $("body").on("change", '.paidby', chgType);

    $("body").on("keydown", 'td', updown);
    chgType();
        $("#scancbill").hide();

    function chgType() {
        var paidby = $(".paidby").val();
        if (paidby == "C") {
            $(".totadv").attr("readonly", true);
            $(".totadv").val("0");
            mainCal();
        } else {
            $(".totadv").removeAttr("readonly", true);

        }
    }
    function updown() {
        var tr = $(this).closest('tr'),
                newsrno = tr.find(".srno").val(),
                srno = parseFloat(newsrno) - 2,
                curcls = $(this).attr('class');

        $(document).keydown(function (event) {
            if (event.keyCode == 40) { // Down key maps to keycode `40`
                if (curcls == 'p2') {
                    $('#rate_' + newsrno).focus();
                    $('#rate_' + newsrno).select();
                } else if (curcls == 'p1') {
                    $('#qty_' + newsrno).focus();
                    $('#qty_' + newsrno).select();
                }
            }
        });


        $(document).keydown(function (event) {
            if (event.keyCode == 38) { // Up key maps to keycode `38`
                if (curcls == 'p2') {
                    $('#rate_' + srno).focus();
                    $('#rate_' + srno).select();
                } else if (curcls == 'p1') {
                    $('#qty_' + srno).focus();
                    $('#qty_' + srno).select();
                }
            }
        });
    }

//    $("body").on("change blur", ".vouchdt", chkSaleDt);
//    $("body").on("click", "#submit ,#cancel", hide_but);

//    function chkSaleDt() {
//        var vouchdt = $(".vouchdt").val();
//        $.post('chkSaleLock.php', {vouchdt: vouchdt}, function (data) {
//            if (data > 0) {
//                $("#submit").hide();
//                $('form').on('keyup keypress', function (e) {
//                    var keyCode = e.keyCode || e.which;
//                    if (keyCode === 13) {
//                        e.preventDefault();
//                        return false;
//                    }
//                });
//            } else {
//                $("#submit").show();
//
//            }
//
//        });
//    }


    var canc_flag = $(".canc_flag").val();
    if (canc_flag != '') {
        $("#scancbill").hide();
        $("#hedit").hide();

    }


    $("#hdelete").hide();


    $("#cancbill").click(function () {
        $("#cancmodel").modal('show');
    });

    function autoaddrow() {
        if ($(this).closest('tr').is(":last-child")) {
            AddRows();
        }
    }

    var lrno = $('.lrno').val();
    if (lrno != '') {
        $(".lrdetail").show();
    } else {
        $(".lrdetail").hide();
    }

//    function getvoucher() {
//        var date = new Date($(".vouchdt").val()),
//                month = (date.getMonth() + 1).toString(),
//                vouchno = $('.vouchno').val(),
//                voucher = '0' + month + vouchno;
//        $('.monno').val(month);
//        $('.voucher').val(voucher);
//    }


    $(".lrtab").click(function () {
        $(".lrdetail").animate({
            height: 'toggle'
        });
    });
//    $('#hedit').click(function () {
//        var addflag = $('.addflag').val();
//        if (addflag != 1) {
//            $('.oms').prop("disabled", true);
//        } else {
//            $('.oms').prop("disabled", false);
//        }
//    });
//    function getgst() {
//        var party = $('.cmbparty').val();
//        $.post('getcustgst.php', {party: party}, function (data) {
////            if (data.gstno != 0) {
//            $('.gstno').val(data.gstno);
////            }
////            $('.mobile').val(data.mobile);
//            $('.transporter').val(data.transporter).trigger('change');
//        }, 'json');
//    }


    function calDetail() {
        var tr = $(this).closest("tr"),
                cartqty = tr.find(".cartqty").val(),
                qty = tr.find(".qty").val(),
                totqty = cartqty * qty,
                rate = tr.find(".rate").val(),
                amount = (rate * qty).toFixed(2),
                discperc = tr.find(".discperc").val(),
                discamt = 0,
                vatperc = tr.find(".vatperc").val(),
                subtot = 0,
                total = 0,
                vat = 0;

        if (discperc > 0) {
            discamt = ((discperc * amount) / 100).toFixed(2);
        } else {
            discamt = tr.find(".discamt").val();
        }
        subtot = amount - discamt;
        if (vatperc > 0) {
            vat = ((vatperc * subtot) / 100).toFixed(2);
        } else {
            vat = 0;
        }
        total = (parseFloat(subtot) + parseFloat(vat)).toFixed(2);
        tr.find(".totqty").val(totqty);
        tr.find(".amount").val(amount);
        tr.find(".discamt").val(discamt);
        tr.find(".vat").val(vat);
        tr.find(".total").val(total);
        var totamt = 0,
                totdisc = 0,
                totvat = 0,
                tottotal = 0,
                totbal = 0,
                totalqty = 0,
                totadv = 0;
        $(".qty").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                totalqty += parseFloat(this.value);
            }
        });
        $(".totalqty").val(totalqty);
        
        $(".amount").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                totamt += parseFloat(this.value);
            }
        });
//        $(".discamt").each(function () {
//            if (!isNaN(this.value) && this.value.lenght != 0) {
//                totdisc += parseFloat(this.value);
//            }
//        });
//        $(".vat").each(function () {
//            if (!isNaN(this.value) && this.value.lenght != 0) {
//                totvat += parseFloat(this.value);
//            }
//        });
        $(".amount").each(function () {
            if (!isNaN(this.value) && this.value.lenght != 0) {
                tottotal += parseFloat(this.value);
            }
        });
        $(".totamt").val(totamt);

//        $(".tottotal").val(tottotal);
        mainCal();
    }
    function mainCal() {
        var tdiscperc = $(".ldiscperc").val(),
                vatperc = $(".tvatperc").val(),
                amount = $(".totamt").val(),
                totadv = $(".totadv").val(),
                discamt = 0, vat = 0,
                totbal = 0;
        if (tdiscperc > 0) {
            discamt = ((tdiscperc * amount) / 100).toFixed(2);
        } else {
            discamt = $(".totdisc").val();
        }
        var subtot = amount - discamt;
        if (vatperc > 0) {
            vat = ((vatperc * subtot) / 100).toFixed(2);
        } else {
            vat = 0;
        }
        var finamt = parseFloat(subtot) + parseFloat(vat),
                totbal = parseFloat(finamt) - parseFloat(totadv);
        $(".totdisc").val(discamt);
        $(".totvat").val(vat);
        $(".tottotal").val(finamt);
        $(".totbal").val(totbal);

    }


    $('#addnew').click(function () {
        AddRows();
    });
    function remove() {
        $(this).closest("tr").remove();
        calDetail();
        caltran();
        mainCal();
    }

    function AddRows() {
        var ctr = $('#items').val();
        var prodtype = $('.prodtype').val();
        var hide_check = "";
        if ($("#del_all").prop("checked")) {
            hide_check = 0;
        } else {
            hide_check = 1;
        }
        var focusFld = ".focusFld_" + ctr;
        ctr++;
        $('#items').val(ctr);
        $.post('sale_add.php', {ctr: ctr, hide: hide_check, prodtype: prodtype}, function (data) {
            $(data).appendTo('.tbody');

            $(focusFld).focus();
        });
    }



});